require 'test/unit'
require 'logicagent'

BasicSocket.do_not_reverse_lookup = true

class TestGAgent < Test::Unit::TestCase

  def setup
    @agent = MyAgent.new
    @agent.send("reset graph")
    @agent.send("set save mode off")
  end

  def test_fuzzy_search
    actual, s = @agent.send("martin wolf is an economist")
    actual, s = @agent.send("who is wolf?")
    #assert_match(/an economist/, actual)
    assert_match(/martin wolf/, actual)

    actual, s = @agent.send("martin wolf == martin wolfe")
    actual, s = @agent.send("who is martin wolfe?")
    assert_match(/martin wolfe is martin wolf, an economist$/, actual)

    actual, s = @agent.send("navkarsi means taking meals 48 minutes after sunrise")
    actual, s = @agent.send("navkarsi = navkar")
    actual, s = @agent.send("what is navkar?")
    assert_match(/48 minutes/, actual)

    actual, s = @agent.send("ratri-bhojan tyaag means renounce all type of food after sunset till next day sunrise")
    actual, s = @agent.send("what does ratri-bhojan mean?")
    #assert_match(/renounce.*food after sunset/, actual)
    assert_match(/tyaag/, actual)

    actual, s = @agent.send("ratri-bhojan == ratri-bhojan tyaag")
    actual, s = @agent.send("what does ratri-bhojan mean?")
    assert_match(/renounce.*food after sunset/, actual)
  end

  def test_fuzzy_search2 
    actual, s = @agent.send("a b c is foo")
    actual, s = @agent.send("what is a?")
    assert_match(/[(foo).*(a b c)]/, actual)
  end

  # Doesn't work.
  def test_has_functions
    actual, s = @agent.send("x has y")
    actual, s = @agent.send("y = z")
    actual, s = @agent.send("does x have y?")
    assert_match(/Yes/i, actual)
    actual, s = @agent.send("does x have z?")
    assert_match(/Yes/i, actual)
  end

  # Fails.
  def test_what_has_x
    actual, s = @agent.send("a has b")
    actual, s = @agent.send("what has b?")
    assert_match(/\ba\b/, actual)
  end

  def test_what_is_a_called
    actual, s = @agent.send("one who has attained keval jnana is called a kevalin.")
    actual, s = @agent.send("what is one who has attained keval jnana called?")
    assert_match(/a kevalin/, actual)
  end

end # class
